module CustomAttributes
  class FloatFieldType < Numeric
    include Singleton

    def cast_single_value(_custom_field, value, _customizable = nil)
      value.to_f
    end

    def validate_single_value(custom_field, value, customizable = nil)
      errs = super
      errs << ::I18n.t('activerecord.errors.messages.invalid') unless begin
                                                                          Kernel.Float(value)
                                                                        rescue
                                                                          nil
                                                                        end
      errs
    end
  end
end
