module CustomAttributes
  class ListFieldType < List
    include Singleton

    def possible_custom_value_options(custom_value)
      options = possible_values_options(custom_value.custom_field)
      missing = [custom_value.value].flatten.reject(&:blank?) - options
      if missing.any?
        options += missing
      end
      options
    end

    def possible_values_options(custom_field, object=nil)
      custom_field.possible_values
    end

    def validate_custom_field(custom_field)
      errors = []
      errors << [:possible_values, :blank] if custom_field.possible_values.blank?
      errors << [:possible_values, :invalid] unless custom_field.possible_values.is_a? Array
      errors
    end

    def validate_custom_value(custom_value)
      values = Array.wrap(custom_value.value).reject {|value| value.to_s == ''}
      invalid_values = values - Array.wrap(custom_value.value_was) - custom_value.custom_field.possible_values
      if invalid_values.any?
        [::I18n.t('activerecord.errors.messages.inclusion')]
      else
        []
      end
    end

  end
end
